#
# @(#)descrip.mms	1.8 03/12/12
ident=descrip.mms	1.8 03/12/12
#
# Top-level OpenVMS MMS "Makefile" for xmcd, labelh, libdi, cdinfo,
# cdda, cddb and util
#
#	xmcd   - Motif(R) CD Audio Player/Ripper
#	labelh - LabelHack widget
#	libdi  - CD Audio Device Interface Library
#	cdinfo - CD Information Management Library
#	cdda   - CD Digital Audio Support
#	cddb   - Classic CDDB Interface Library
#	util   - Utility functions
#
#   Contributing author: Hartmut Becker
#   Copyright (C) 1993-2004  Ti Kan
#   E-mail: xmcd@amb.org
#
#
# Just type 'MMS', the makefile traverses into each subdirectory
# and uses local descrip.mms files to build xmcd.
#
# To make a quick debug versions, just set symbols for cc and link, like
#	$ cc:=cc/deb
#	$ link:=link/debug
# To do real debugging remove the "/opt..." from the MMS files and
# set $ cc:=cc/deb/noopt or edit the MMS files for those modules you want to
# debug.
#
# The supplied MAKEVMS.COM is generated by this makefile.
# If one of the descrip.mms changes, please generate a new COM file
# with
#	mms makevms
#
# The MAKEVMS.COM can be used to build xmcd by users who do not have MMS.
#
#
#   This program is free software; you can redistribute it and/or modify
#   it under the terms of the GNU General Public License as published by
#   the Free Software Foundation; either version 2 of the License, or
#   (at your option) any later version.
#
#   This program is distributed in the hope that it will be useful,
#   but WITHOUT ANY WARRANTY; without even the implied warranty of
#   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#   GNU General Public License for more details.
#
#   You should have received a copy of the GNU General Public License
#   along with this program; if not, write to the Free Software
#   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
#

.ifdef	mms
.else
mms= mms
.endif

all :
	$! $(makevms)$(ident)$(now)
	set def [.common_d]
	@ $(mms)
	set def [-.cdda_d]
	@ $(mms)
	set def [-.libdi_d]
	@ $(mms)
	set def [-.cddb_d]
	@ $(mms)
	set def [-.cdinfo_d]
	@ $(mms)
	set def [-.labelh_d]
	@ $(mms)
	set def [-.xmcd_d]
	@ $(mms)
	set def [-]

makevms :
	@ $(mms)/macro=(mms="mms/noaction/from/out",now=", at ''f$time()'",$@="$@.COM, generated from ")-
		/out=$@.com all

clean :
	purge [...]
	- del [.*]*.obj;
	- del [.*]*.olb;
	- del [.xmcd_d]*.opt;

clobber : clean
	- del [.xmcd_d]*.exe;
	- del [.xmcd_d]*.map;
	- del makevms.com;
