.\"
.\" @(#)xmcd.man	7.117 04/04/21
.\"
.\"   xmcd - Motif(R) CD Audio Player/Ripper
.\"
.\"   Copyright (C) 1993-2004  Ti Kan
.\"   E-mail: xmcd@amb.org
.\"
.\"   This program is free software; you can redistribute it and/or modify
.\"   it under the terms of the GNU General Public License as published by
.\"   the Free Software Foundation; either version 2 of the License, or
.\"   (at your option) any later version.
.\"
.\"   This program is distributed in the hope that it will be useful,
.\"   but WITHOUT ANY WARRANTY; without even the implied warranty of
.\"   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
.\"   GNU General Public License for more details.
.\"
.\"   You should have received a copy of the GNU General Public License
.\"   along with this program; if not, write to the Free Software
.\"   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
.\"
.TH XMCD 1 "04/04/21" "v3.3.2"

.SH "NAME"
xmcd \- CD digital audio player utility for X11/Motif

.SH "SYNOPSIS"
.B xmcd
.nh
[\fItoolkitoption ...\fP] [-\fIdev\fP device]
[-\fIinstcmap\fP] [-\fIremote\fP] [-\fIrmthost\fP hostname] [-\fIhelp\fP]
[-\fIdebug\fP level#] [-\fIc\fP device] [-\fIX\fP] [-\fIo\fP]
[\fIcommand\fP [\fIarg\fP ...]]

.SH "DESCRIPTION"
.I Xmcd
is a program that allows the use of the CD-ROM, CD-R, CD-RW or DVD
drive as a full-featured stereo compact-disc player and "ripper"
for the X window system.  See \fBcda\fR(1) for the command-line
CD player.
.I xmcd
and
.I cda
uses the same configuration and support files.
.PP
Most of the features found on "real" CD players are available in
.I xmcd,
such as shuffle and repeat, track programming functions,
a numeric keypad and track warp slider for direct track access.
Additional functions include sample play, A to B segment play,
volume control, balance control, etc.  Several automation
options are also available on CD load, eject, play completion
and program exit.  A Channel Routing feature allow you to
select from several stereo or mono routing options.  The
volume control slider taper characteristics can also be
altered.
.PP
CDDA (CD digital audio) data extraction, playback, save-to-file,
and pipe-to-program are supported on many platforms.  For
data extraction to file or pipe,
.I xmcd
can generate the data in MP3 (MPEG-1 layer 3), MPEG-2/MPEG-4 AAC, MP4,
Ogg Vorbis, FLAC, WAV, AU, AIFF, AIFF-C and raw headerless formats.
Simultaneous extraction to file/pipe and real-time playback is
possible on high performance computers.
.PP
Multi-disc changers are also supported.  There are buttons
to switch to the next or previous disc in the changer, as well
as a way to switch to a specific disc via the keypad.  You can
select to play only a single disc or auto-play all discs in
normal or reverse order.
.PP
The Gracenote CDDB(R) Music Recognition Service(sm) is supported by
.I xmcd,
which allows the CD artist/title and track titles, and other
information associated with the loaded CD to be displayed.
You may also add/modify and submit information to the CDDB service.
For CDDA extraction to MP3, MP4, Ogg Vorbis and FLAC formats,
.I xmcd
can auto-fill the CD information tags embedded in these files.
.PP
This release of
.I xmcd
supports the enhanced Gracenote CDDB2(R) service on a number of platforms,
and offers much richer features and content than the "classic" CDDB service.
Moreover, CDDB2-supplied information is now in UTF-8
data format, providing international language support.
See "LOCALIZATION" below.
.PP
.I Xmcd
provides the ability to drive a web browser and search for web
sites related to the currently playing CD artist or track.
You may also access online music reviews and go to the official
.I xmcd
and
.I Gracenote
web sites, invoke the CDDB Music Browser(tm),
as well as CDDB-provided links to related content.
Moreover, the browser integration gives
users the ability to manage \fILocal Discography\fR information
pertaining to their CD collections.
.PP
In addition to CDDB, this release of
.I xmcd
supports reading CD-TEXT data from the disc for the disc/track
artist and title information.
.PP
Full feature-specific pop-up help is available for
all controls, indicators, text input fields, and lists.
.PP
On systems with more than one CD drive, multiple
invocations of
.I xmcd
can be used to operate each drive independently.
.PP
.I Xmcd
is designed to be easy to use, as the main window is
purposely made to resemble a real CD player front panel.
All other pop-up windows are also designed to be as
intuitive as possible.  Moreover, while the use of a mouse
is natural with
.I xmcd,
all functionality can also be operated via the keyboard.
This is in conformance to the guidelines published in the
.I OSF/Motif Style Guide
from the Open Software Foundation.
.PP
Many functions on a running
.I xmcd
session can be "remote controlled"
from the command line via the -\fIremote\fP option.  See the "OPTIONS"
section below.
.PP
The internal architecture of
.I xmcd
is designed to be easily portable to many UNIX operating
system variants, and adaptable to the myriad of CD drives
available.

.SH "OPTIONS"
All standard \fIXt Intrinsics\fR toolkit options are supported
(such as -\fIdisplay\fP, -\fIgeometry\fP. -\fIiconic\fP, etc.).
In addition,
.I xmcd
supports the following options:
.sp
.TP
\fI\-dev\ device\fR
.br
Specifies the path name to the raw CD device.  If this option is
not used, the default device to be used is the first
drive set up with the
.I xmcd
configuration program (See below).
.TP
\fI\-help\fR
Causes command line usage information to be displayed on \fIstderr\fR.
.TP
\fI\-debug\ level#\fR
Causes verbose debugging diagnostics to be displayed on \fIstderr\fR.
The level specifies the type of debugging messages desired:
.sp
.nf
1	General debugging
2	Device I/O debugging
4	CD information debugging
8	User interface debugging
16	Remote control debugging
32	Sound DSP and output file/pipe debugging
64	Message of the day debugging
.fi
.sp
You may add the values together to enable multiple debugging types
(i.e., A value of 3 turns on both General and Device I/O debugging).
.TP
\fI\-instcmap\fR
Causes
.I xmcd
to install its own colormap.  This may be desirable if
.I xmcd
is to be used at the same time as other color-intensive
applications, which would otherwise cause
.I xmcd
to be unable to
allocate all its needed colors.  Note that when running on an X
display that does not support many concurrent colormaps, this may
cause other windows to change colors when
.I xmcd
has the input focus.
.TP
\fI\-remote\fR
Causes a command to be sent to another running
.I xmcd
process.
The command and appropriate arguments are specified at the
invoking shell (or shell script) as command-line arguments,
After the command is delivered, the "sender"
.I xmcd
process exits,
and the "receiver" process responds by executing the command.
In effect, the sender becomes a remote control for a running
.I xmcd
session.  See "COMMANDS" below for a list of supported
commands.
.sp
The sender
.I xmcd
process can be invoked on the same host or on
a different host than the receiver
.I xmcd
process.  By default,
the sender will attempt to locate an
.I xmcd
process running on the
same X display (determined by the DISPLAY environment variable
or the -\fIdisplay\fP option), and controlling the same
default CD device.  You may specify the device via the -\fIdev\fP
option to override the default.  Use of the -\fIdev\fP and
-\fIrmthost\fP options on the sender's command line can resolve
ambiguities when there are multiple
.I xmcd
clients displaying on the
same X server.
.TP
\fI\-rmthost\ hostname\fR
This may be used with the -\fIremote\fP option to specify the host
on which the receiver
.I xmcd
client must be running.
.TP
\fI\-c\ device (Solaris only)\fR
Same as the
.I -dev
option.
.TP
\fI\-X (Solaris only)\fR
Causes the \fBexitOnEject\fR parameter to be set to True.
.TP
\fI\-o (Solaris only)\fR
This option has no effect.
.PP
The
.I -c, -X
and
.I -o
options are provided only on the Solaris platform
for compatibility with the
.I action_workman.so
auto-startup program, running under the Solaris Volume Manager (\fIvold\fP).
See the PLATFORM file in the
.I xmcd
distribution about configuring
.I xmcd
for the Solaris Volume Manager.

.SH "X RESOURCES"
.I Xmcd
has many adjustable X resources to customize its look and feel, as well
as its behavior.  Notably, the colors of virtually every feature on
\fIxmcd\fR's windows can be changed, as well as the text fonts.  All
text labels can also be changed (for example, to another language).
.PP
There are too many resources to list here, but the resource names
and their defaults (plus descriptive comments) can be found in the
\fBXMCDLIB\fI/app-defaults/XMcd\fR
file (where XMCDLIB is the xmcd library directory specified during
installation, typically \fI/usr/lib/X11/xmcd\fR).
It is not recommended
that you change values in the \fBXMCDLIB\fI/app-defaults/XMcd\fR file,
unless you want the changes to be forced upon all users of
.I xmcd
on the system.  Instead, make a copy of this file, change the copy as you
see fit, then place it in your $HOME/.xmcdcfg directory.  Your custom
resource settings will then override the defaults when
.I xmcd
is subsequently started.

.SH "COMMANDS"
You may specify a command as an xmcd command line argument,
to make xmcd execute the command after initial startup.
For example, the following command starts
.I xmcd
and then begins playing at track 4:
.sp
.in +4
\fBxmcd play 4 &\fP
.in -4
.sp
.PP
If the -\fIremote\fP option is used, then the command is
sent to another running xmcd process for execution (See "OPTIONS"
above).
.PP
The supported commands are:
.PP
.TP
\fIstop\fR
Stop playback.
.TP
\fIplay [track# | min:sec | track#:min:sec]\fR
Start playback.  You may also specify the starting track number,
and/or the starting minute and second offset.
.TP
\fIpause\fR
Pause the playback.  You may resume the playback by using either
the \fIpause\fP command again, or the \fIplay\fP command.
.TP
\fIsample\fR
Start sample playback.  This will play the first 10 seconds of each
track.
.TP
\fIdisc \<load | eject | prev | next | disc#>\fR
Perform a disc operation:  Load or eject the CD, or change to
another disc on a multi-disc changer.
.TP
\fItrack <prev | next | track#>\fR
Perform a track operation: Change to the previous or next track, or
a specified track number.
.TP
\fIindex <prev | next>\fR
Perform an index operation: Change to the previous or next index.
.TP
\fIlock <on | off>\fR
Enable or disable the caddy (or disc tray) lock.  When enabled,
pressing the eject button on the drive will not eject the CD.
You can only change the lock state when a CD is loaded and is not playing.
.TP
\fIshuffle <on | off>\fR
Enable or disable shuffle (random play) mode.  Shuffle can be
enabled in this manner only when playback is not in progress.  When
shuffle is enabled, any program sequence is cleared and segment
play is canceled.
.TP
\fIrepeat <on | off>\fR
Enable or disable repeat mode.
.TP
\fIprogram <clear | save | track# ...>\fR
Clear, save or set a track program sequence.  Track numbers may be space or
comma-separated.  When a program is set in this manner, shuffle mode
will be disengaged and segment play will be canceled.
.TP
\fIvolume <value# | linear | square | invsqr>\fR
Volume control operation.  You can specify a numeric value to set
the volume level (The range is 0 to 100), or change the volume control's
taper characteristic: linear, square, or inverse-square.  This control
operates the hardware volume control on the CD drive in \fIStandard
playback\fR mode, or the computer's audio hardware in \fICDDA playback\fR
mode.  It has no effect on the data of the \fICDDA save to file\fR or
\fICDDA pipe to program\fR outputs.
.TP
\fIbalance value#\fR
Balance control.  The value should be between 0 and 100.   50 is center,
0 is full-left, and 100 is full-right.  This control
operates the hardware volume control on the CD drive in \fIStandard
playback\fR mode, or the computer's audio hardware in \fICDDA playback\fR
mode.  It has no effect on the data of the \fICDDA save to file\fR or
\fICDDA pipe to program\fR outputs.
.TP
\fIroute <stereo | reverse | mono-l | mono-r | mono | value#>\fR
Channel routing control.  Use one of the appropriate keywords, or
a value as follows:
.sp
.nf
0	Normal stereo
1	Reverse stereo
2	Mono-L
3	Mono-R
4	Mono-L+R
.fi
.TP
\fIoutport <speaker | headphone | line-out | value#>\fR
CDDA playback output port selection.  The \fIspeaker\fR, \fIheadphone\fR
and \fIline-out\fR keywords are toggles.  Alternatively, you may
specify a numeric \fIvalue\fR, as follows:
.sp
.nf
1	Speaker
2	Headphone
4	Line-out
.fi
.sp
You may add the values together to enable multiple output ports
(i.e., A value of 3 turns on both Speaker and Headphones).
When the value is set to 0, the port setting is unmodified.
Note that this command may be meaningful only on some platforms,
and only certain ports may be available on a particular architecture.
See the PLATFORM file for details.
.TP
\fIcdda-att <value#>\fR
CDDA attenuator level.  The valid range is 0 to 100.
Note that in contrast to the \fIvolume\fR command, this setting
does not operate any hardware.  It works by scaling the CDDA
audio samples, and thus has no effect in \fIStandard playback\fR
mode, but affects all CDDA modes (\fICDDA playback\fR,
\fICDDA save to file\fR and \fICDDA pipe to program\fR).
.TP
\fItime <elapse | e-seg | e-disc | r-trac | r-seg | r-disc>\fR
Change the time display mode.  Select from elapsed track time,
elapsed segment time, elapsed disc time, remaining track time,
remaining segment time or remaining disc time.
.TP
\fIon-load <none | spindown | autoplay | autolock | noautolock>\fR
Enable or disable options when a CD is loaded.  The
.I spindown
option will cause the CD to stop after loading to conserve the laser
and motor.  The
.I autoplay
option will cause the CD to automatically start playing after loading.  The
.I autolock
option causes the caddy or disc tray to be automatically locked.  The
.I none,
.I spindown
and
.I autoplay
options are mutually-exclusive.
.TP
\fIon-exit <none | autostop | autoeject>\fR
Enable or disable options when
.I xmcd
exits.  The
.I autostop
option will cause xmcd to stop playback,
and the
.I autoeject
option will cause xmcd to eject the CD.  Use
.I none
to cancel these options.
.TP
\fIon-done <autoeject | noautoeject | autoexit | noautoexit>\fR
Enable or disable options when
.I xmcd
is done with playback.  The
.I autoeject
option causes xmcd to eject the CD.  The
.I autoexit
option will cause xmcd to exit.
.TP
\fIon-eject <autoexit | noautoexit>\fR
Enable or disable options when
.I xmcd
ejects a CD.  The
.I autoexit
option will cause xmcd to exit after ejecting the CD.
.TP
\fIchanger <multiplay | nomultiplay | reverse | noreverse>\fR
Enable or disable multi-disc changer options.  The
.I multiplay
option specifies that
.I xmcd
plays all discs in sequence.  The
.I nomultiplay
option will cause xmcd to stop after the current disc is done.
The
.I reverse
option implies
.I multiplay,
except that the disc order is reversed.
.TP
\fImode <standard | cdda-play | cdda-save | cdda-pipe>\fR
Selects the playback mode.  See "PLAYBACK MODES" below for details
about the modes.
.TP
\fIjittercorr <on | off>\fR
Enable or disable CDDA jitter correction.
.TP
\fItrackfile <on | off>\fR
For \fICDDA save to file\fR mode, specifies whether a separate
file should be created for each CD track.
.TP
\fIsubst <on | off>\fR
For \fICDDA save to file\fR mode, specifies whether space and tab
characters in the output file path name should be substituted with
underscores ('_').  This makes the files easier to manipulate while
using the UNIX command shell.
.TP
\fIfilefmt <format>\fR
Specifies the output audio file format if running in
\fICDDA save to file\fR or \fICDDA pipe to program\fR modes.
The \fIformat\fR is one of the following:
raw, au, wav, aiff, aiff-c, mp3, ogg, flac, aac or mp4.
.TP
\fIoutfile <template>\fR
Specifies the output audio file path name template if running in
\fICDDA save to file\fR mode.  See the help file for the CDDA output
file path template text box for a description on the special tokens
that could be used in the template.
.TP
\fIpipeprog <path [arg ...]>\fR
Specifies the external program to which the audio stream will be piped to
when running in \fICDDA pipe to program\fR mode.
.TP
\fIcompress <<0 | 3> [bitrate#] | <1 | 2> [qual#]>\fR
Selects the compression mode for compressed file formats, as follows:
.sp
For MP3, the modes are as follows:
.nf
0	Constant bitrate (CBR)
1	Variable bitrate (VBR, old algorithm)
2	Variable bitrate (VBR, new algorithm, faster)
3	Average bit rate (ABR)
.fi
.sp
For Ogg Vorbis and MP4, all modes are VBR, as follows:
.nf
0, 3	Use an average bit rate
1, 2	Use a quality factor
.fi
.sp
For FLAC, the modes are as follows:
.nf
0	None
1	Enable exhaustive LP coefficient quant. search
2	Enable encoding correctness verification
3	Enable both
.fi
.sp
For AAC, all modes are VBR, as follows:
.nf
0	Use an average bit rate, MPEG-2
1	Use a quality factor, MPEG-2
2	Use a quality factor, MPEG-4
3	Use an average bit rate, MPEG-4
.fi
.sp
For modes \fI0\fR and \fI3\fR, an optional bitrate (in kb/s)
sub-argument can be specified.  The supported bitrates are a discrete
set of numbers from 32 to 320.  A value of 0 can also be used to indicate
the use of an internal default.  For modes \fI1\fR and \fI2\fR, an optional
quality factor (from 1 to 10) sub-argument can be used.
Lower bitrates and quality factor values yield smaller
files whereas higher numbers produce higher audio quality.
For AAC and MP4 formats, the bitrate you specify will be double the
actual bitrate (e.g., if you specify 128kbps, the actual bitrate used
will be 64kbps).  The bitrate or quality values, if specified, are
ignored for the FLAC format.
.TP
\fImin-brate <bitrate#>\fR
In average bitrate and variable bitrate modes, this commands lets you
specify a low bitrate limit.  The encoder will not drop below this limit
while dynamically changing the bitrate.  A value of 0 can be specified
to indicate the use of an internal default.
This parameter has no effect on the FLAC, AAC or MP4 format.
.TP
\fImax-brate <bitrate#>\fR
In average bitrate and variable bitrate modes, this commands lets you
specify a high bitrate limit.  The encoder will not go above this limit
while dynamically changing the bitrate.  A value of 0 can be specified
to indicate the use of an internal default.
This parameter has no effect on the FLAC, AAC or MP4 format.
.TP
\fIcoding <stereo | j-stereo | force-ms | mono | algo#>\fR
This command selects the stereo mode and encoding
noise-shaping/psychoacoustics algorithm.
.sp
For MP3, the algorithm is a number from 1 to 10.  Lower numbers gives
faster encoding whereas higher numbers produce higher audio quality.
.sp
For AAC and MP4, \fIstereo\fR disables the mid/side coding,
\fIj-stereo\fR and \fIforce-ms\fR are synonymous, and \fImono\fR
is not supported.  An algorithm value of 10 enables
temporal noise shaping (TNS).
.sp
For FLAC, the stereo modes have no effect, but the algorithm value
selects between faster encoding versus slightly better compression.
.sp
For Ogg Vorbis, this parameter has no effect.
.TP
\fIlowpass <off | auto | freq# [width#]>\fR
This allows a lowpass filter to be added.
The \fIoff\fR setting means no filter, the \fIauto\fR setting causes the
encoder to determine whether a filter should be added and its parameters.
Specifying a frequency (and optionally, a width) will enable the filter
in manual mode.  The frequency and width are both in Hz.  The valid
frequency range is from 16 to 50000 Hz.
For MP3, the filter functions fully as described.
For AAC and MP4, the \fIfreq\fR can be used to limit the bandwidth, but
the \fIwidth\fR value is ignored.
For Ogg Vorbis and FLAC, these parameters have no effect.
.TP
\fIhighpass <off | auto | freq# [width#]>\fR
For encoding to MP3 files, this allows a highpass filter to be added.
The \fIoff\fR setting means no filter, the \fIauto\fR setting causes the
encoder to determine whether a filter should be added and its parameters.
Specifying a frequency (and optionally, a width) will enable the filter
in manual mode.  The frequency and width are both in Hz.  The valid
frequency range is from 500 to 50000 Hz.  The lower limit is imposed by
the polyphase filter implementation in the MP3 encoder.
For non-MP3 formats, these parameters have no effect.
.TP
\fIflags <[C|c][O|o][P|p][E|e][I|i]>\fR
This allows you to specify some MP3 header and frame flags.
The letter \fIc\fR denotes the "copyright" flag, the letter \fIo\fR
denotes the "original" flag, the letter \fIn\fR denotes the "no res"
(disable bit reservoir) flag, the letter \fIe\fR denotes the addition
of a 2-byte checksum to each frame for error correction, and the letter
\fIi\fR indicates strict ISO compatibility.  The use of a upper-case
letter turns on the flag, and lower-case turns off the flag.  Multiple
flags may be specified together.
.TP
\fItag <off | v1 | v2 | both>\fR
This command specifies whether CD information (such as album and track
artists and titles, genre type, etc.) should be added to the CDDA output
file.  For MP3, the information is added to either the version 1, version 2
or both versions of the ID3 tag areas.  For Ogg Vorbis, FLAC and MP4,
the information is added to the metadata area.
to 
.br
Note: An ID3v2 tag will not be added to the \fICDDA pipe to program\fR
MP3 stream regardless of the setting of this command.
.TP
\fIlameopts <<disable | insert | append | replace> [options]>\fR
This command allows you to query or set command line options to
be passed directly to the LAME MP3 encoder, and control how those
options will be passed.  This facilitates the use of advanced or
experimental LAME features that cannot otherwise be invoked via the
.I xmcd
graphical user interface for setting encoding parameters.
The following keywords control how the command line options
are to be passed:
.sp
\fIdisable\fR: No additional command line options are to be passed.
.br
\fIinsert\fR: The specified options are to be inserted before
the standard options.
.br
\fIappend\fR: The specified options are to be appended after
the standard options.
.br
\fIreplace\fR: The specified options are to be used instead of
the standard options.
.sp
Standard options refers to the command line options that
.I xmcd
generates, based on the current settings of the controls in
the "Encoding Parameters" options window.
.TP
\fImotd\fR
Retrieve and display messages from the xmcd MOTD server, if any.
.TP
\fIwindow <modechg | iconify | deiconify | raise | lower>\fR
.I Xmcd
window control.  The
.I modechg
command causes the
.O xmcd
main window to toggle between the normal mode and basic mode.  In normal
mode, all controls and indicators are available.  In basic mode,
.I xmcd
shrinks to a smaller size and only basic controls are shown.
The
.I iconify,
.I deiconify,
.I raise
and
.I lower
commands cause the
.I xmcd
window to change as specified.
.TP
\fIquit\fR
Causes xmcd to exit.
.TP
\fIdebug <level#>\fR
Set the debug level.  When debug level is non-zero,
.I xmcd
generates verbose debugging diagnostics to be displayed on \fIstderr\fR.
See the description for the \fI-debug\fR option above for supported level
values.
.PP
Some of these commands, when used in start-up mode, do not
perform a meaningful function.  For example, the "\fItrack prev\fP"
command is not useful just after xmcd startup.  It is more appropriate
to use this command in the remote control mode.

.SH "DEVICE CONFIGURATION"
The X resources described in the previous section affect the
general appearance and behavior of
.I xmcd.
There are two additional configuration files which are used
to adapt
.I xmcd
to your site requirements.  The first of these contain
common parameters, and the second contain
configurable parameters that must vary on a
per-drive basis.  For example, in some cases
.I xmcd
must operate the drive differently depending upon the brand
and model of the drive.  Thus, there must be a separate
configuration file for these parameters \fIper-device\fR.
The common parameters file is \fBXMCDLIB\fI/config/common.cfg\fR
and the device-specific parameters file is
\fBXMCDLIB\fI/config/\fBDEVICE\fR
(where XMCDLIB is typically \fI/usr/lib/X11/xmcd\fR and DEVICE is
the base name of the raw device special file for the CD drive;
e.g., \fI/usr/lib/X11/xmcd/config/rcd0\fR).
A configuration program \fBXMCDLIB\fI/config/config.sh\fR
is provided to make maintaining these configuration
file easy (Note: on SCO UNIX/Open Desktop/Open Server systems the
configuration program can also be invoked as "\fImkdev xmcd\fR").
.PP
You should always use the configuration program to set the
configuration parameters when installing
.I xmcd
for the first time, or when the CD hardware configuration has
changed.  If this is not done then
.I xmcd
will probably not operate correctly with your CD drive.
.PP
.B WARNING:
If
.I xmcd
is not correctly configured, you may cause
.I xmcd
to deliver commands that are not supported by your CD drive.
Under some environments this may lead to system hang or crash.
.PP
You can override some of the device-specific configuration parameters
by adding your own configuration files.
.I Xmcd
will also look in the
\fB$HOME\fI/.xmcdcfg/common.cfg\fR and
\fB$HOME\fI/.xmcdcfg/\fBDEVICE\fR files for
common and device-specific parameters (where $HOME is your home
directory and DEVICE is as specified above).  Parameters found in
this file will override the system defaults (except those
parameters that cannot be overridden; see the comments in the
\fBXMCDLIB\fI/config/device.cfg\fR for details).

.SH "USING XMCD"
The basic functions of
.I xmcd
are designed to operate the same way as on a real stereo CD player.
The pictorial symbols used on the main window buttons are intended
to illustrate the function in a non-language-specific manner.  If
enabled, a small "tooltip" will appear after a short delay, when
you position the mouse cursor over any xmcd main window feature.
The tooltip contains textual description of the feature.
.PP
The CD information and track programming functions are operated
via the CD Information subwindow.  You open the subwindow by clicking the
.B CD Information
button (file cabinet symbol) on the main window (See "CD DATABASE" below).
.PP
There is not a per-item description of all the features here,
because full on-line help is available (See "ONLINE HELP" below).

.SH "ONLINE HELP"
For general information about
.I xmcd,
click the \fBwwwWarp\fR (world symbol) button on the
.I xmcd
main window and select '\fIXmcd help...\fR' in the menu.  You can also
get specific help information about each button, control,
indicator, text entry area, selection list by positioning the
mouse cursor over the desired item, then clicking the third mouse
button.  A pop-up window will appear, containing the relevant
help text.

.SH "TRACK PROGRAMMING"
You can program
.I xmcd
to play only certain tracks, in a custom sequence.
To do so, invoke the CD Information window (by clicking the
.B CD Information
button on the main window).  Select the desired track
by clicking on the entry in the
.B Track list,
and click the
.B Add
button to add to the play sequence.  Notice that the track number
appears in the
.B Program sequence
text field.  You can also type the track numbers, separated with
commas or spaces, directly in the
.B Program sequence
field.  Repeat until all desired tracks have been entered,
then click the
.B Play/Pause
button (on the main window) to start the program play.
.PP
When a program sequence is defined, the
.B prog
indicator in the main window display area "illuminates".
To erase the program sequence, click the
.B Clear
button on the CD Information window.  You may also
.B Save
a program sequence, so that the next time you load the same CD
the program will automatically be applied.  The
.I Clear
button will also delete the saved program.

.SH "CD DATABASE"
Unless explicitly disabled,
.I xmcd
will automatically query the Gracenote CDDB Music Recognition Service
for information about the loaded CD.  This information includes the
artist/title, track titles, genre, and much more, and is
displayed on the CD Information window and several of its
sub-windows.

You may also add, modify or enhance the displayed
information, in the rare circumstance that CDDB does not have data
pertaining to your CD, or if the CDDB-supplied data is incomplete or
in error.  You can then submit the changes back to CDDB.
.PP
You should perform a "submit" operation (click the
.B Submit
button) after typing in the changed information before ejecting
the CD or exiting, or the information will be lost.
.PP
The CD Information window should prove to be intuitive to use.
You may use the on-line help system to obtain specific help
information about the various buttons and items.
.PP
The CD information, once queried from CDDB, is stored in a local cache
and managed by the CDDB library.  This reduces unnecessary Internet
connections to the CDDB servers.
.PP
This release of
.I xmcd
also supports reading the CD-TEXT data from the disc
for CD information.  Only some recent CDs are produced with
CD-TEXT data and this data can only be read on CD drives with
CD-TEXT capability.
.PP
For backward compatibility, this release of
.I xmcd
will also read the old-style local CD database files previously
generated by xmcd versions 1.x and 2.x.  No capability is retained
in this release to write/update the old-style CD database files.
.PP
The priority of the CD information schemes (CDDB, CD-TEXT or local CD
database files) is controlled via the cdinfoPath parameter in the
\fBcommon.cfg\fR file.
.PP
For more information about
.I Gracenote\ CDDB,
read the CDDB file included with this release, and visit the
.I http://www.cddb.com
web site for details.
.PP
While
.I xmcd
is running, the file \fB/tmp/.cdaudio/curr.\fInnnn\fR (where
nnnn is the hexadecimal representation of the CD drive's
device number) contains the device node path, the music genre,
and disc identification information pertaining to the currently loaded CD.
Other applications may read this file to identify the
currently loaded disc.

.SH "PLAYBACK MODES"
This release supports the following user-selectable playback modes
(via the Options pop-up window):
.sp
.TP
\fIStandard playback\fR
.br
When playing an audio CD, the audio output is the analog "line out"
connection on the back of your CD drive.  There should be an audio
cable connecting this output to your computer audio hardware CD
input (or to an externally amplfied speaker or stereo system).  The
audio output is also available at the CD drive's front panel
headphone connection, if so equipped.  The volume control slider bar on
.I xmcd
affect the CD drive's built-in volume control, if the drive has such
controls.  This is the mode that previous releases
(\fIxmcd\fR version 1.x through 3.0) supported.
.sp
.TP
\fICDDA playback\fR
.br
When playing a CD in this mode,
.I xmcd
extracts the CD digital audio data off the CD drive over the
data cable (e.g., SCSI or ATAPI/IDE).  Then, it sends the data to the
DSP (digital signal processor) device in your computer's audio hardware
for real-time playback.  The audio is typically heard through the
computer's built-in speakers.  No signal is produced at the line-out
or headphone connections of the CD drive.  The
.I xmcd
volume control slider bar affects the computer's DSP device.
.sp
.TP
\fICDDA save to file\fR
.br
When playing a CD in this mode,
.I xmcd
extracts the CD digital audio data off the CD drive over the
data cable (e.g., SCSI or ATAPI/IDE).  Then, it writes the data
into a file of your choosing.  The
.I xmcd
volume control slider does not affect the data written to
the output file.  The output file format can be selected to be one
of the following:
.sp
.nf
Format Ext   Description
------ ----- ---------------------------------------
RAW    .raw  Little-endian, 16 bit, 44.1 kHz, stereo
AU     .au   Big-endian, 16 bit, 44.1 kHz, stereo
WAV    .wav  Little-endian, 16 bit, 44.1 kHz, stereo
AIFF   .aiff Big-endian, 16 bit, 44.1 kHz, stereo
AIFF-C .aifc Big-endian, 16 bit, 44.1 kHz, stereo
MP3    .mp3  MPEG 1.0 Layer III compressed
Ogg    .ogg  Ogg Vorbis compressed
FLAC   .flac Free Lossless Audio CODEC compressed
AAC    .aac  AAC (MPEG-2 or MPEG-4) compressed
MP4    .mp4  MP4 (MPEG-4) compressed
.fi
.sp
The file can be played later using an appropriate playback utility,
or converted to another format.  This mode will typically run faster than
real-time with the non-compressed formats.  With the compressed formats,
it depends on the CPU performance of your system.
.sp
.TP
\fICDDA pipe to program\fR
.br
When playing a CD in this mode,
.I xmcd
extracts the CD digital audio data off the CD drive over the
data cable (e.g., SCSI or ATAPI/IDE).  Then, it pipes the data
stream to an external program that you specify.  The output
format is selected as in the \fICDDA save to file\fR mode.
This mode can be used with an external audio player, encoder, or
other digital audio manipulation program.
The external program must be capable of accepting audio data on its
standard input, in one of the formats listed above.
.PP
More than one of the three CDDA modes can be selected at the same time.
For example, if both the \fICDDA playback\fR and the
\fICDDA save to file\fR buttons are selected, the two functions
will be performed simultaneously.  Note that on most systems, only one
program can access the system's DSP at a time, therefore you will
likely not be able to select \fICDDA playback\fR and
\fICDDA pipe to program\fR at the same time, where the external program
is itself an audio player.
.PP
\fBNOTE\fR: The CDDA (CD digital audio) modes will function only on
CD drives that provides this capability, and only on some OS and hardware
platforms.  See the RELNOTES file for details about platform support and
other CDDA related notes.

.SH "LOCALIZATION"
There is full localization support in
.I xmcd
if it is compiled with X11R5 or later header files and libraries.
.PP
The "classic" CDDB service supplies data in the ISO Latin-1 format only, 
multi-byte characters are not supported.
.PP
The CDDB2 service supplies data in UTF-8 data format, which is
identical to US-ASCII for single-byte characters.  Multi-byte UTF-8
characters are also supported when xmcd is linked with X11R5 or later.
By default, xmcd will translate the characters to ISO Latin-1
(ISO 8859-1, for English and many European character sets).
By changing the setting of the \fBcharsetConvMode\fR parameter in
the \fBcommon.cfg\fR file, you can have
.I xmcd
display the UTF-8 data without conversion (good for US-ASCII
or if you are using UTF-8 fonts),
or attempt to convert UTF-8 strings to the default character set
as specified by the \fBLANG\fR environment variable.  This conversion
will occur only if the system's list of locales also support UTF-8.
As distributed,
.I xmcd
is configured to display in a generic family of X fonts denotes similar
to the following:
.sp
.in +4
-*-helvetica-bold-o-*--14-140-*
.in -4
.sp
This will normally work correctly with English and any ISO Latin-1
European character set, as long as your X display server supports all the
required fonts.  To display in other languages, you must set your
LANG environment accordingly, and change
.I xmcd
to use the appropriate fonts.  That can be accomplished by
modifying the various XMcd*\fIclassname\fR.fontList parameters in the
XMCDLIB/app-defaults/XMcd file (system wide) or your $HOME/.xmcdcfg/XMcd
file (per-user).  Be sure that the fonts you specify is actually supported
by your X display server.  See \fBxlsfonts\fR(1) and your X window system
documentation about font configuration.
.PP
Moreover, all titles and descriptions in xmcd are configurable in the
XMcd X resource file.  US-English is distributed by default, but the file
may be modified to use any other language as desired.  See "X RESOURCES"
above.

.SH "NOTES"
Not all platforms and CD drives support all the features of
.I xmcd.
For example, some drives do not support a software-driven
volume control.  On these drives the
.I xmcd
volume control slider may have no effect, or in some cases it is
made to function as a mute control (i.e., it will snap to the
full-off or full-on positions only).  Similarly, the \fBcaddy lock\fR,
\fBeject\fR and \fBindex search\fR buttons found on
.I xmcd
may not have any effect on drives that do not support the
appropriate functionality.
.PP
The remote control feature (using the -\fIremote\fP option)
is governed by the standard display server security mechanisms of the
X window system.  In order for an
.I xmcd
sender client to communicate
with a running
.I xmcd
receiver client, the sender must have the
appropriate access permissions to the receiver client's X display.
See \fBxhost\fR(1), \fBxauth\fR(1) and \fBXsecurity\fR(1)
for more information.  If logging is enabled, remote control activity
is logged by the xmcd receiver client in the $HOME/.xmcdcfg/remote.log
file for each xmcd user.
.PP
The lame(1) MP3 encoder program must be installed on your system in
order for
.I xmcd
to perform CD ripping to MP3 format files.  Similarly, the
faac(1) encoder program must be installed on your system for
the AAC and MP4 formats.
.PP
Your copy of the
.I xmcd
executable must be compiled and linked with the Ogg Vorbis and FLAC encoder
libraries in order to perform CD ripping to these formats.  See the
INSTALL file for details.

.SH "ENVIRONMENT VARIABLES"
The \fBLANG\fR environment variable sets the default character set.
See "LOCALIZATION" above.
.PP
For the \fBwwwWarp\fR feature, xmcd invokes the Netscape, Mozilla, Galeon
or Opera web browser to display the contents.  Xmcd searches a number of
"standard" locations for the web browser executable.  If you have multiple
browsers installed and would like to direct xmcd to use a
particular executable, or if your browser executable is installed in
a non-standard location, then you may set the \fBBROWSER_PATH\fR environment
variable on the shell command line to the web browser executable you
desire.
.PP
An example:
.in +4
.nf
.sp
(For Bourne Shell and Korn Shell users):
BROWSER_PATH=/usr/local/bin/mozilla; export BROWSER_PATH
.sp
(For C Shell users):
setenv BROWSER_PATH /usr/local/bin/mozilla
.fi
.in -4
.PP
you may put the above command in your $HOME/.profile (sh/ksh) or
$HOME/.cshrc (csh) to set this automatically each time you log in.
.PP
The \fBLAME_PATH\fR environment variable may be used to specify the
path to the lame(1) MP3 encoder program.
.PP
The \fBFAAC_PATH\fR environment variable may be used to specify the
path to the faac(1) AAC and MP4 encoder program.
.PP
The \fBAUDIODEV\fR environment variable may be used to specify an
alternate audio device when running xmcd in the \fICDDA playback\fR mode.
The default audio device is write method dependent as follows:
.in +4
.nf
.sp
AIX write method:	/dev/paud0/1	(PCI audio)
AIX write method:	/dev/baud0/1	(MCA audio)
ALSA write method:	plughw:0,0
HP-UX write method:	/dev/audio
Linux/OSS write method:	/dev/dsp
OSF1 write method:	0
Solaris write method:	/dev/audio
.fi
.PP
In addition, with the OSS and ALSA write methods, the \fBMIXERDEV\fR
environment variable may be used to specify the PCM mixer channel device.
The default is \fI/dev/mixer\fR for OSS, and \fIdefault\fR for ALSA.
.PP
On FreeBSD with ATAPI CD drives, xmcd will automatically use either
the CDIOCREADAUDIO ioctl or the pread(2) system call for CDDA reads,
based on the running kernel version.  You may override the default
by setting the environment variable \fBCDDA_USE_PREAD\fR to 0 or 1,
respectively.  Normally this is not necessary.

.SH "FILES"
$HOME/.cddb2/\(**
.br
$HOME/.xmcdcfg/\(**
.br
XMCDLIB/app-defaults/XMcd
.br
XMCDLIB/cdinfo/\(**
.br
XMCDLIB/discog/\(**
.br
XMCDLIB/doc/\(**
.br
XMCDLIB/config/config.sh
.br
XMCDLIB/config/common.cfg
.br
XMCDLIB/config/device.cfg
.br
XMCDLIB/config/.tbl/\(**
.br
XMCDLIB/config/\(**
.br
XMCDLIB/help/\(**
.br
BINDIR/xmcd
.br
MANDIR/xmcd.1
.br
/tmp/.cdaudio/\(**

.SH "RELATED WEB SITES"
Xmcd/cda web site: \fIhttp://www.amb.org/xmcd/\fR
.br
Gracenote web site: \fIhttp://www.cddb.com/\fR
.br
Xmmix web site: \fIhttp://www.amb.org/xmmix/\fR
.br
LAME MP3 encoder: \fIhttp://www.mp3dev.org/\fR
.br
Ogg Vorbis: \fIhttp://www.xiph.org/ogg/vorbis/\fR
.br
FLAC (Free Lossless Audio CODEC): \fIhttp://flac.sourceforge.net/\fR
.br
FAAC (AAC/MP4 encoder): \fIhttp://www.audiocoding.com/\fR
.br
Hydrogen Audio (discussion forums): \fIhttp://www.hydrogenaudio.org/\fR
.br
Sox audio format conversion utility: \fIhttp://www.spies.com/Sox/\fR

.SH "SEE ALSO"
cda(1), X(1), xhost(1), xauth(1), Xsecurity(1), xlsfonts(1),
lame(1), faac(1), sox(1)
.br
Xmcd's README, PLATFORM, DRIVES, INSTALL and RELNOTES files

.SH "AUTHOR"
Ti Kan (\fIxmcd@amb.org\fR)
.br
AMB Laboratories, Sunnyvale, CA, U.S.A.
.br
.I Xmcd
also contains code contributed by several dedicated individuals.
See the ACKS file in the
.I xmcd
distribution for information.
.br
Comments, suggestions, and bug reports are always welcome.
